import * as plugins from './plugins.js';

export class TspmConfig {
  public npmextraInstance = new plugins.npmextra.KeyValueStore({
    identityArg: '@git.zone__tspm',
    typeArg: 'userHomeDir',
  })

  public async readKey(keyArg: string): Promise<string> {
    return await this.npmextraInstance.readKey(keyArg);
  }

  public async writeKey(keyArg: string, value: string): Promise<void> {
    return await this.npmextraInstance.writeKey(keyArg, value);
  }

  public async deleteKey(keyArg: string): Promise<void> {
    return await this.npmextraInstance.deleteKey(keyArg);
  }
}